<?php
Class Create{
	Private $conn, $DBlib, $typ;
	
	Public function __construct(){
		$details = new XmlConfig();
		$srvDetaily = $details->getServerDet($_GET['server']);
		$typ = $srvDetaily['Typ'];
		
		if ($typ == "mssql"){$this->DBlib = new MssqlClass();}
		else{$this->DBlib = new MysqlClass();}	
		$this->conn = $this->DBlib->connect($srvDetaily['Name'],$srvDetaily['Login'],$srvDetaily['Psw']);
		if(!$this->conn){
			echo "Nelze se pipojit k DB serveru<br /><br />";	
		}
		
		switch ($_GET['object']){
			case 'DB':
				$this->createDB();
			break;
			
			case 'table':
				$this->createTable();
			break;
			
			case 'field':
				$this->createField();
			break;
			
			case 'item':
				$this->createItem();
			break;
			
			default:
				echo "Pro takov objekt nen vytven poloek povoleno!";
			break;
		}
	}
	
	Private function createItem(){
		$this->DBlib->setDB($_GET['DB']);
			
		if(isset($_GET['confirm'])){
			$columns = $_POST['columns'];
			
			for($i=0;$i<$_POST['numFields'];$i++){
				$valuePerRow = array();
				foreach($columns as $column){
				$valuePerRow[] = $_POST[$column][$i];
				}
				$values[] = $valuePerRow;
			}
			
			echo $this->DBlib->createItem($_GET['table'],$columns,$values);
		}
		else{
			$table = $this->DBlib->describeTable($_GET['table'],$_GET['DB']);
			foreach($table as $key){$columns[] = $key[0];}
			
			if(isset($_POST['numFields'])){$numFields = $_POST['numFields'];}
			else{$numFields=1;}
			if(isset($_POST['plusFields'])){$plusFields = $_POST['plusFields'];}
			else{$plusFields = 0;}
			if(is_numeric($plusFields)){
			$numFields += $plusFields;			
	
			echo "<img src='img/additem.png'><h2>Pidat dek do tabulky ".$_GET['table']."</h2>";
			echo "<form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&object=item&confirm&active=2' method='POST'>";
			echo "<input type='hidden' name='numFields' value='$numFields'>";
			foreach($columns as $key){
				echo "<input type='hidden' name='columns[]' value='$key'>";
			}
			echo "<table>";
			echo "<tr>";
			foreach($columns as $column){
			 	echo "<th>$column</th>";	
			}
			echo "</tr>";
			for($i=0;$i<$numFields;$i++){
				echo "<tr>";
				foreach($columns as $column){
			 	echo "<td><input type='text' name='".$column."[]' value=''></td>";	
				}
				echo "</tr>";	
			}
			echo "<tr><td colspan='2'><input type='submit' value='Pidat' /></td></tr>";
			echo "<table>";
			echo "</form>";
			echo "<br /><form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&object=item&active=2' method='POST'>";
			echo "Pidat poet sloupc <input type='text' name='plusFields'> <input type='submit' value='Pidat' />";
			echo "<input type='hidden' name='numFields' value='$numFields'>";
			echo "</form>";
			}
			else{
				echo "Poet pol mus bt cel slo<br />";
				echo "<form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&object=item&active=2' method='POST'>";
				echo "<table>";
				echo "<tr><td colspan='2'><input type='submit' value='Zpt' /></td></tr>";
				echo "<table>";
				echo "</form>";
			}
		}
	}
	
	Private function createDB(){
		if(isset($_GET['confirm'])){
			$message = $this->DBlib->createDB($_POST['nameDB'], $_POST['collation']);
			echo "$message";
			echo "<meta http-equiv='refresh' content='1;url=index.php?act=viewDB&server=".$_GET['server']."&active=1'>";
		}
		else{
			echo "<img src='img/adddb.png'><h2>Vytvoit novou databzi</h2>";
			echo "<form action='index.php?act=create&server=".$_GET['server']."&active=1&object=DB&confirm' method='POST'>";
			echo "<table>";
			echo "<tr>";
			echo "<td>Nzev DB</td><td><input type='text' name='nameDB' value='' /></td>";
			echo "</tr>";
			echo "<tr>";
			echo "<td>Srovnvn</td>";
			echo "<td>";
			echo "<select name='collation'>";
			$collations = $this->DBlib->getCollation();
			foreach ($collations as $collation){
				echo "<option value='".$collation[0]."'>".$collation[0]."</option>";
			}
			echo "</select>";
			echo "</td>";
			echo "</tr>";
			echo "<tr><td colspan='2'><input type='submit' value='Vytvoit'></td></tr>";
			echo "</table>";
			echo "</form>";
		}
	}
	
	Private function createTable(){
		if(isset($_GET['confirm'])){
				for($i=0;$i<$_POST['numFields'];$i++){
					$columns[] = array('name'=>$_POST['name'][$i],'type'=>$_POST['type'][$i],'length'=>$_POST['length'][$i],'null'=>$_POST['null'][$i],'default'=>$_POST['default'][$i],'flags'=>$_POST['flags'][$i],'primaryKey'=>$_POST['primaryKey'][$i]); 
				}
				$this->DBlib->setDB($_GET['DB']);
				echo $this->DBlib->createTable($_POST['nameTable'],$columns);
				
		}
		else{
			switch ($_GET['step']){
			case 1:
				echo "<img src='img/addtable.png'><h2>Vytvoit novou tabulku</h2>";
				echo "Prvodce tvorbou tabulky (krok 1 ze 3)<br />";
				echo "<form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&object=table&active=2&step=2' method='POST'>";
				echo "<table>";
				echo "<tr><td>Nzev tabulky</td><td><input type='text' name='nameTable'></td></tr>";
				echo "<tr><td>Poet sloupc</td><td><input type='text' name='numFields'></td></tr>";
				echo "<tr><td colspan='2'><input type='submit' value='Dal' /></td></tr>";
				echo "<table>";
				echo "</form>";
			break;	
			
			case 2:
				$numFields = $_POST['numFields'];
				if(isset($_POST['plusFields'])){$plusFields = $_POST['plusFields'];}
				else{$plusFields = 0;}
				if(is_numeric($numFields) AND is_numeric($plusFields)){
				$numFields += $plusFields;
				$nameTable = $_POST['nameTable'];
				echo "<img src='img/addtable.png'><h2>Vytvoit novou tabulku</h2>";
				echo "Prvodce tvorbou tabulky (krok 2 ze 3)<br />";
				echo "<form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&object=table&active=2&step=3' method='POST'>";
				echo "<input type='hidden' name='nameTable' value='$nameTable'>";
				echo "<input type='hidden' name='numFields' value='$numFields'>";
				echo "<table>";
				echo "<tr>" .
						"<th>Jmno sloupce</th>" .
						"<th>Typ</th>" .
						"<th>Dlka</th>" .
						"<th>Null</th>" .
						"<th>Defaultn hodnota</th>" .
						"<th>Extra vlastnosti</th>" .
						"<th>Primrn kl</th>" .
						"</tr>";
				for($i=1;$i<=$numFields;$i++){
				echo "<tr>" .
						"<td><input type='text' name=name[] /></td>" .
						"<td>" .
						"<select name=type[]>";
							$types = $this->DBlib->getDataTypes();
							foreach ($types as $type){
								echo "<option value='$type'>$type</option>";
							}
				echo	"</select>".
						"</td>" .
						"<td><input type='text' name='length[]'></td>" .
						"<td><select name='null[]'>".
						"<option value='NOT NULL'>NOT NULL</option>".
						"<option value='NULL'>NULL</option>".
						"</select></td>".
						"<td><input type='text' name='default[]'></td>" .
						"<td><select name='flags[]'>".
						"<option value=''> </option>".
						"<option value='auto_increment'>Auto_increment</option>".
						"</select></td>".
						"<td><select name='primaryKey[]'>".
						"<option value=''> </option>".
						"<option value='primary_key'>Primary key</option>".
						"</select></td>".
						"</tr>";
				}
				echo "<tr><td colspan='2'><input type='submit' value='Dal' /></td></tr>";
				echo "<table>";
				echo "</form>";
				echo "<br /><form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&object=table&active=2&step=2' method='POST'>";
				echo "Pidat poet sloupc <input type='text' name='plusFields'> <input type='submit' value='Pidat' />";
				echo "<input type='hidden' name='nameTable' value='$nameTable'>";
				echo "<input type='hidden' name='numFields' value='$numFields'>";
				echo "</form>";
				}
				else{
				echo "Poet pol mus bt cel slo<br />";
				echo "<form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&object=table&active=2&step=1' method='POST'>";
				echo "<table>";
				echo "<tr><td colspan='2'><input type='submit' value='Zpt' /></td></tr>";
				echo "<table>";
				echo "</form>";
				}
			break;
			
			case 3:
				echo "<img src='img/addtable.png'><h2>Vytvoit novou tabulku</h2>";
				echo "Prvodce tvorbou tabulky (krok 3 ze 3)<br />";
				echo "<form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&object=table&active=2&confirm' method='POST'>";
				$name = $_POST['name'];
				$type = $_POST['type'];
				$length = $_POST['length'];
				$null = $_POST['null'];
				$default = $_POST['default'];
				$flags = $_POST['flags'];
				$primaryKey = $_POST['primaryKey'];
								
				echo "<input type='hidden' name='nameTable' value='".$_POST['nameTable']."'>";
				echo "<input type='hidden' name='numFields' value='".$_POST['numFields']."'>";
				for($i=0;$i<$_POST['numFields'];$i++){
				echo "<input type='hidden' name='name[]' value='$name[$i]'>";
				echo "<input type='hidden' name='type[]' value='$type[$i]'>";
				echo "<input type='hidden' name='length[]' value='$length[$i]'>";
				echo "<input type='hidden' name='null[]' value='$null[$i]'>";
				echo "<input type='hidden' name='default[]' value='$default[$i]'>";
				echo "<input type='hidden' name='flags[]' value='$flags[$i]'>";
				echo "<input type='hidden' name='primaryKey[]' value='$primaryKey[$i]'>";
				}
				echo "<table>";
				echo "<tr><td></td><td></td></tr>";
				echo "<tr><td colspan='2'><input type='submit' value='Vytvoit' /></td></tr>";
				echo "<table>";
				echo "</form>";
			break;
			}
			
		}
	}	
	
	Private function createField(){
		if(isset($_GET['confirm'])){
				for($i=0;$i<$_POST['numFields'];$i++){
					$columns[] = array('name'=>$_POST['name'][$i],'type'=>$_POST['type'][$i],'length'=>$_POST['length'][$i],'null'=>$_POST['null'][$i],'default'=>$_POST['default'][$i],'flags'=>$_POST['flags'][$i],'primaryKey'=>$_POST['primaryKey'][$i]); 
				}
				$this->DBlib->setDB($_GET['DB']);
				echo $this->DBlib->addColumns($_GET['table'],$columns);
				
		}
		else{	
			if(isset($_POST['numFields'])){$numFields = $_POST['numFields'];}
			else{$numFields=1;}
			if(isset($_POST['plusFields'])){$plusFields = $_POST['plusFields'];}
			else{$plusFields = 0;}
			if(is_numeric($plusFields)){
			$numFields += $plusFields;			
	
			echo "<img src='img/addcolumn.png'><h2>Pidat sloupec do tabulky ".$_GET['table']."</h2>";
			echo "<form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&object=field&confirm&active=5' method='POST'>";
			echo "<input type='hidden' name='numFields' value='$numFields'>";
			echo "<table>";
			echo "<tr>" .
						"<th>Jmno sloupce</th>" .
						"<th>Typ</th>" .
						"<th>Dlka</th>" .
						"<th>Null</th>" .
						"<th>Defaultn hodnota</th>" .
						"<th>Extra vlastnosti</th>" .
						"<th>Primrn kl</th>" .
						"</tr>";
			for($i=0;$i<$numFields;$i++){
			echo "<tr>" .
						"<td><input type='text' name=name[] /></td>" .
						"<td>" .
						"<select name=type[]>";
							$types = $this->DBlib->getDataTypes();
							foreach ($types as $type){
								echo "<option value='$type'>$type</option>";
							}
			echo	"</select>".
						"</td>" .
						"<td><input type='text' name='length[]'></td>" .
						"<td><select name='null[]'>".
						"<option value='NOT NULL'>NOT NULL</option>".
						"<option value='NULL'>NULL</option>".
						"</select></td>".
						"<td><input type='text' name='default[]'></td>" .
						"<td><select name='flags[]'>".
						"<option value=''> </option>".
						"<option value='auto_increment'>Auto_increment</option>".
						"</select></td>".
						"<td><select name='primaryKey[]'>".
						"<option value=''> </option>".
						"<option value='primary_key'>Primary key</option>".
						"</select></td>".
						"</tr>";
				}
			echo "<tr><td colspan='2'><input type='submit' value='Pidat' /></td></tr>";
			echo "<table>";
			echo "</form>";
			echo "<br /><form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&object=field&active=5' method='POST'>";
			echo "Pidat poet sloupc <input type='text' name='plusFields'> <input type='submit' value='Pidat' />";
			echo "<input type='hidden' name='numFields' value='$numFields'>";
			echo "</form>";
			}
			else{
				echo "Poet pol mus bt cel slo<br />";
				echo "<form action='index.php?act=create&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&object=field&active=5' method='POST'>";
				echo "<table>";
				echo "<tr><td colspan='2'><input type='submit' value='Zpt' /></td></tr>";
				echo "<table>";
				echo "</form>";
			}
		}
	}
	
	Public function __destruct(){
		$this->DBlib->close($this->conn);
	}
	
}
?>
