<?php
Class Delete{
	Private $DBlib,$conn;
	
	Public function __construct(){
		
		$details = new XmlConfig();
		$srvDetaily = $details->getServerDet($_GET['server']);
		$typ = $srvDetaily['Typ'];
		
		if ($typ == "mssql"){$this->DBlib = new MssqlClass();}
		else{$this->DBlib = new MysqlClass();}	
		$this->conn = $this->DBlib->connect($srvDetaily['Name'],$srvDetaily['Login'],$srvDetaily['Psw']);
		if(!$this->conn){
			echo "Nelze se pipojit k DB serveru<br /><br />";	
		}
		
		$object = $_GET['object'];
		switch ($object){
			case 'DB':
				$this->deleteDB($_GET['DB']);
			break;
			
			case 'table':
				$this->deleteTable($_GET['DB'],$_GET['table']);
			break;
			
			case 'field':
				$this->deleteField($_GET['DB'], $_GET['table'], $_GET['field']);
			break;
			
			case 'tabletrunc':
				$this->truncTable($_GET['DB'],$_GET['table']);
			break;
			
			case 'DF':
				$this->delDF($_GET['DB'], $_GET['table'], $_GET['field']);
			break;
			
			case 'row':
				echo 'dek byl vymazn!';
				$row = $_POST['numRow'];
				$row = "row".$row;
				$row = $_POST[$row];
				$heads = $_POST['heads'];
				$this->DBlib->setDB($_GET['DB']);
				$this->DBlib->delItem($_GET['table'],$heads,$row);
				
			break;			
		}
	}
	
	Private function deleteDB($nameDB){
				
		if(isset($_POST['confirm'])){
		$message = $this->DBlib->dropDB($nameDB);
		echo "<h2>$message</h2>";
		echo "<meta http-equiv='refresh' content='1;url=index.php?act=viewDB&server=".$_GET['server']."&active=1'>";
		
		}
		else{
		echo "<img src='img/deldb.png'><h2>Opravdu chcete odstranit ze serveru ".$_GET['server']." databzi ".$_GET['DB']."?</h2>";
		echo "<table><tr>";
		echo "<td><form action='index.php?act=del&server=".$_GET['server']."&DB=".$_GET['DB']."&object=DB&active=1' method='POST'>";
		echo "<input type='hidden' name='confirm' />";
		echo "<input type='submit' value='Smazat'>";
		echo "</form></td>";		
		echo "<td><form action='index.php?act=viewDB&server=".$_GET['server']."&DB=".$_GET['DB']."&active=0' method='POST'><input type='submit' value='Zpt'></form></td>";
		echo "</tr></table>";	
		}
		
	}
	
	Private function deleteTable($nameDB,$nameTable){
	
		if(isset($_POST['confirm'])){
		$this->DBlib->setDB($nameDB);
		$message = $this->DBlib->dropTable($nameTable);
		echo "<h2>$message</h2>";
		echo "<meta http-equiv='refresh' content='1;url=index.php?act=viewDB&server=".$_GET['server']."&DB=".$_GET['DB']."&active=1'>";
		
		}
		else{
		echo "<img src='img/deltable.png'><h2>Opravdu chcete odstranit z databze ".$_GET['DB']." tabulku ".$_GET['table']."?</h2>";
		echo "<table><tr>";
		echo "<td><form action='index.php?act=del&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&object=table&active=1' method='POST'>";
		echo "<input type='hidden' name='confirm' />";
		echo "<input type='submit' value='Smazat'>";
		echo "</form></td>";		
		echo "<td><form action='index.php?act=viewDB&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."' method='POST'><input type='submit' value='Zpt'></form></td>";
		echo "</tr></table>";	
		}	
	
	}
	
	Private function truncTable($nameDB, $nameTable){
		if(isset($_POST['confirm'])){
		$this->DBlib->setDB($nameDB);
		$this->DBlib->truncateTable($nameTable);
		echo "<h2>Obsah tabulky byl vymazn</h2>";
		echo "<meta http-equiv='refresh' content='1;url=index.php?act=viewDB&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&active=1'>";
		}
		else{
		echo "<h2>Opravdu chcete odstranit obsah tabulky ".$_GET['table']."?</h2>";
		echo "<table><tr>";
		echo "<td><form action='index.php?act=del&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&object=tabletrunc&active=1' method='POST'>";
		echo "<input type='hidden' name='confirm' />";
		echo "<input type='submit' value='Smazat'>";
		echo "</form></td>";	
		echo "<td><form action='index.php?act=viewDB&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."' method='POST'><input type='submit' value='Zpt'></form></td>";
		echo "</tr></table>";	
		}
	}
	
	Private function deleteField($nameDB, $table, $nameField){
		if(isset($_POST['confirm'])){
		$this->DBlib->setDB($nameDB);
		echo $this->DBlib->dropColumn($table, $nameField);
		echo "<h2>Sloupec byl z tabulky odstrann</h2>";
		echo "<meta http-equiv='refresh' content='1;url=index.php?act=viewDB&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&active=1'>";
		}
		else{
		echo "<img src='img/delcolumn.png'><h2>Opravdu chcete odstranit z tabulky ".$_GET['table']." sloupec ".$_GET['field']."?</h2>";
		echo "<table><tr>";
		echo "<td><form action='index.php?act=del&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&field=".$_GET['field']."&object=field&active=1' method='POST'>";
		echo "<input type='hidden' name='confirm' />";
		echo "<input type='submit' value='Smazat'>";
		echo "</form></td>";		
		echo "<td><form action='index.php?act=viewDB&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."' method='POST'><input type='submit' value='Zpt'></form></td>";
		echo "</tr></table>";
		}
	}
	
	Private function delDF($nameDB, $table, $nameField){
		if(isset($_POST['confirm'])){
		$this->DBlib->setDB($nameDB);
		echo $this->DBlib->dropDF($table, $nameField);
		echo "<h2>Constraint pro defaultn hodnotu byl odstrann ze sloupce $nameField</h2>";
		echo "<meta http-equiv='refresh' content='1;url=index.php?act=viewDB&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&active=1'>";
		}
		else{
		echo "<form action='index.php?act=del&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&field=".$_GET['field']."&object=DF&active=1' method='POST'>";
		echo "<h2>Opravdu chcete odstranit z tabulky ".$_GET['table'].", sloupce ".$_GET['field']." constraint pro defaultn hodnotu?</h2>";
		echo "<input type='hidden' name='confirm' />";
		echo "<input type='submit' value='Smazat'>";
		echo "</form>";		
		}
	}
	
	Public function __destruct(){
		$this->DBlib->close($this->conn);	
	}
	
}

?>
