<?php
Class MysqlClass{
	Private $typesNotLength = array('boolean','double','date','datetime','time','tinyblob','tinytext','mediumblob','mediumtext','longblob','longtext');
	
	Public function connect($server,$username,$password){
	  $conn = @mysql_connect($server,$username,$password);
	  return $conn;
	}
	
	Public function close($conn){
		@mysql_close($conn);
	}
	
	Public function setDB($nameDB){
		mysql_select_db($nameDB);
	}
	
	//server/////////////////////////////////////////////////////////
	Public function getDatabases($connection){
		$db_list = @mysql_list_dbs($connection);
		$dbss = array();
		while ($dbs = @mysql_fetch_object($db_list)) {
			$dbss[] = $dbs->Database;
		}
		return $dbss;
	}
	
	Public function getStatus($connection){
		$result["infoStat"] = mysql_stat($connection);
		$result["verzeServeru"] = mysql_get_server_info($connection);
		$result["host"] = mysql_get_host_info($connection);
		return $result;
	}
	
	Public function getTables($database){
		$this->setDB($database);
		$result = $this->getRowsQuery("SHOW TABLES");
		if(count($result) == 0){
		    $vysl[] = "Nenalezeny dn tabulky!";	
		}
		else{
		 foreach($result as $key){
		  $vysl[] = $key[0];	
		 }
		}
		return $vysl;
	}
	
	Public function getTablesDetailed($database){
		$result = $this->getRowsQuery("SHOW TABLE STATUS ");
		return $result;
	}
	
	Public function getCharacterSets(){
		$result = $this->getRowsQuery("SHOW CHARACTER SET");
		return $result;
	}
	
	Public function getCollation(){
		$result = $this->getRowsQuery("SHOW COLLATION");
		return $result;
	}
	
	Public function getDataTypes(){
		$result = array('bit','boolean','smallint','mediumint','int','bigint','float','double','decimal','date','datetime','timestamp','time','year','char','varchar','binary','varbinary','tinyblob','tinytext','blob','text','mediumblob','mediumtext','longblob','longtext');
		return $result;
	}	
	//query/////////////////////////////////////////////////////////
	Public function getRowsQuery($dotaz){
		$result = @mysql_query($dotaz);
		$vysl = array();
		while ($line = @mysql_fetch_row($result)){
			$vysl[] = $line;
		}
		if(count($vysl) == 0){$vysl[] = array("Nebyly nalezeny dn zznamy!");}
		return @$vysl;
	}
	
	Public function getResultSQL($query){
		$test_vyrazu = eregi("^[[:blank:]]*(delete|insert|create|grant )",$query);
		if ($test_vyrazu == 0){
			$content = mysql_query($query);
			if (!$content){
 				$return = array('fields'=>array("Chyba v SQL dotazu"), 'content'=>array(array(mysql_error())));	
 			}
 			else{
 				$num_rows = mysql_num_rows($content);
 				$num_fields = mysql_num_fields($content);
 				$i = 0;	
 				while ($i < $num_fields){
  				$fields[] = mysql_field_name($content,$i);
  				$i++;
  				}
  				while ($line = mysql_fetch_row($content)){
				$vysl[] = $line;
				}
				$return = array('fields'=>$fields, 'content'=>$vysl);
 			}
 				
		}
		else{
			$content = $this->simpleQuery($query);
			$return = array('fields'=>array("Vsledek dotazu"), 'content'=>array(array($content)));		
		}
		return $return;
	}
	
	Public function simpleQuery($dotaz){
		$result = @mysql_query($dotaz);
		if(mysql_info()){$return = mysql_info();}
		else{$return = mysql_error();}
		
		return $return;
	}
	//DB/////////////////////////////////////////////////////////
	Public function createDB($name, $collation){
		$result = $this->simpleQuery("CREATE DATABASE $name COLLATE $collation");
		return $result;
	}
	
	Public function dropDB($name){
		$result = $this->simpleQuery("DROP DATABASE $name");
		return $result;
	}
	
	Public function renameDB($oldName, $newName){
		$result = $this->simpleQuery("RENAME DATABASE $oldName TO $newName");
		return $result;
	}
	//table/////////////////////////////////////////////////////////
	Public function createTable($tableName, $columns){
		$createStr = "CREATE TABLE $tableName (";
		foreach ($columns as $key){
		 $createStr .= " ".$key['name']." ".$key['type'];
		 if (!in_array($key['type'], $this->typesNotLength) AND $key['length'] != ""){
		 	$createStr .= " (".$key['length'].") ";
		 }		
		 if ($key['default'] != ""){$createStr .= " DEFAULT '".$key['default']."'";}
		 $createStr .= " ".$key['null'];
		 if ($key['flags'] !=""){$createStr .= " auto_increment";}
		 if ($key['primaryKey'] !=""){$createStr .= " PRIMARY KEY";}
 		 $createStr .= ",";	 	
		}
		$createStr = substr($createStr, 0, -1);
		$createStr .= ") ENGINE=MyISAM";
	
		echo $createStr."<br />";
		$result = $this->simpleQuery($createStr);
		return $result;
	}
	
	Public function truncateTable($tableName){
		$result = $this->simpleQuery("TRUNCATE $tableName");
		return $result;
	}
	
	Public function dropTable($tableName){
		$result = $this->simpleQuery("DROP TABLE $tableName");
		return $result;
	}
	
	Public function renameTable($oldName, $newName){
		$result = $this->simpleQuery("RENAME TABLE $oldName TO $newName");
		return $result;
	}
		
	Public function describeTable($tableName,$db){
		$this->setDB($db);
		$result = $this->getRowsQuery("DESCRIBE $tableName");
		if(count($result) == 0){
		    $vysl[] = arary("Nenalezeny"," dn", " sloupce!");	
		}
		else{
		 foreach($result as $key){
			$vysl[] = array($key[0],$key[1],$key[2],$key[4]);
		 }
		}
		return $vysl;
	}
	
	//columns/////////////////////////////////////////////////////////
	Public function getColumns($table){
		$result = $this->getRowsQuery("SHOW COLUMNS FROM $table");
		return $result;
	}
	
	Public function addColumns($table,$columns){
		$createStr = "ALTER TABLE $table ";
		foreach ($columns as $key){
		 $createStr .= " ADD ".$key['name']." ".$key['type'];
		 if (!in_array($key['type'], $this->typesNotLength) AND $key['length'] != ""){
		 	$createStr .= " (".$key['length'].") ";
		 }		
		 if ($key['default'] != ""){$createStr .= " DEFAULT '".$key['default']."'";}
		 $createStr .= " ".$key['null'];
		 if ($key['flags'] !=""){$createStr .= " auto_increment";}
		 if ($key['primaryKey'] !=""){$createStr .= " PRIMARY KEY";}
 		 $createStr .= ",";	 	
		}
		$createStr = substr($createStr, 0, -1);
		
		echo $createStr."<br />";
		$result = $this->simpleQuery($createStr);
		return $result;
	}
	
	Public function dropColumn($table,$nameCol){
		$result = $this->simpleQuery("ALTER TABLE $table DROP COLUMN $nameCol");
		return $result;
	}
	
	Public function alterColumn($table,$columns){
		$createStr = "ALTER TABLE $table ";
		$createStr .= " MODIFY ".$columns['name']." ".$columns['type'];
		 if (!in_array($columns['type'], $this->typesNotLength) AND $columns['length'] != ""){
		 	$createStr .= " (".$columns['length'].") ";
		 }		
		 if ($columns['default'] != ""){$createStr .= " DEFAULT '".$columns['default']."'";}
		 $createStr .= " ".$columns['null'];
		 if ($columns['flags'] !=""){$createStr .= " auto_increment";}
		 if ($columns['primaryKey'] !=""){$createStr .= " PRIMARY KEY";}
 		 $createStr .= ",";	 	
		
		$createStr = substr($createStr, 0, -1);
		
		echo $createStr."<br />";
		$result = $this->simpleQuery($createStr);
		return $result;
	}
	
	Public function getColumnDetail($tableName,$column){
		$return = $this->getRowsQuery("SHOW COLUMNS FROM $tableName LIKE '$column'");
		$return = $return[0];
		$typLen = split("\(",$return[1]);
		$typ = $typLen[0];
		$length = substr($typLen[1], 0, -1);
		if($return[5] != ""){$identity = "YES";}
		else{$identity = "NO";}
		if($return[3] != ""){$primary = "YES";}
		else{$primary = "NO";}
				
		$return = array($return[0],$typ,$length,$return[2],$return[4],$identity,$primary);
		return $return;
	}
	
	Public function createItem($tableName,$columns,$values){
		$createStr = "INSERT INTO $tableName (";
		foreach($columns as $column){
		$createStr .= "$column,";
		}
		$createStr = substr($createStr, 0, -1);
		$createStr .= ") VALUES";
		foreach($values as $row){
			$createStr .= " ('";
			$createStr .= implode("','",$row);
			$createStr .= "'),";
		}
		$createStr = substr($createStr, 0, -1);
		
		echo $createStr."<br />";
		$result = $this->simpleQuery($createStr);
		return $result;
	}
	
	Public function delItem($table, $heads, $items){
		$delStr = "DELETE FROM $table WHERE ";
		for($i=0;$i<count($heads);$i++){
			$toDel[] = $heads[$i]."='".$items[$i]."'";
		}
		$delStr .= implode(" AND ",$toDel);
		echo "<br />".$delStr."<br />";
		$result = $this->simpleQuery($delStr);
		return $result;		
	}
	
	Public function updateItem($table, $heads, $itemsOld, $itemsNew){
		$updStr = "UPDATE $table SET ";
		for($i=0;$i<count($heads);$i++){
			$toUpd[] = $heads[$i]."='".$itemsNew[$i]."'";
		}
		$updStr .= implode(", ",$toUpd);
		$toUpd = array();
		$updStr .= " WHERE ";
		for($i=0;$i<count($heads);$i++){
			$toUpd[] = $heads[$i]."='".$itemsOld[$i]."'";
		}
		$updStr .= implode(" AND ",$toUpd);
		echo "<br />".$updStr."<br />";
		$result = $this->simpleQuery($updStr);
		return $result;	
	}
	//users/////////////////////////////////////////////////////////
	Public function createUser($userName,$password){
		$createStr = "CREATE USER $userName ";
		if(trim($password) != ""){
			$createStr .= " IDENTIFIED BY '$password'";
		}
		echo $createStr;
		$result = $this->simpleQuery($createStr);
		return $result;
	}
	
	Public function getUsers(){
		$this->setDB("mysql");
		$getStr = "SELECT * FROM user";
		$result = $this->getRowsQuery($getStr);
		foreach($result as $item){
		if($item[2] == ''){$psw = 'NO';}
		else{$psw = 'YES';}
		$vysl[] = array('',$item[1], $item[0], $psw);
		}
		return $vysl;
	}
	
	Public function granPrivileges($user,$database,$privilegesDB,$privilegesAll){
		$this->simpleQuery("REVOKE ALL ON $database FROM $user");
		if(!empty($privilegesDB)){
			$grandStr = "GRANT ";
			$grandStr .= implode(",",$privilegesDB);
			/*foreach($privilegesDB as $key){
				$grandStr .= " $key,";
			}
			$grandStr = substr($grandStr, 0, -1);*/
			$grandStr .= " ON $database.* TO $user";
			$result = $this->simpleQuery($grandStr);
		}
		echo $grandStr;
		$grandStr = '';
		if(!empty($privilegesAll)){
			$grandStr = "GRANT ";
			$grandStr .= implode(",",$privilegesAll);
			/*foreach($privilegesAll as $key){
				$grandStr .= " $key,";
			}
			$grandStr = substr($grandStr, 0, -1);*/
			$grandStr .= " ON *.* TO $user";
			echo $grandStr;
			$result = $this->simpleQuery($grandStr);
		}
		return $result;
	}
	
	Public function dropUser($userName){
		$result = $this->simpleQuery("DROP USER $userName");
		return $result;
	}
	
	Public function exportTable($tables, $adrName){
		$backupStr = "BACKUP TABLE ".implode(",",$tables)." TO '$adrName'";
		echo $return = $this->simpleQuery($backupStr);
		return $return;
	}
	
	Public function importTable($tables, $adrName){
		$restoreStr = "RESTORE TABLE ".implode(",",$tables)." FROM '$adrName'";
		echo $return = $this->simpleQuery($restoreStr);
		return $return;
	}
	///////import/export
	//$backupFile = $dbname . date("Y-m-d-H-i-s") . '.gz';
	//$command = "mysqldump --opt -h $dbhost -u $dbuser -p $dbpass $dbname | gzip > $backupFile";
	//system($command);
	
}
?>
