<?php
Class ViewDB{
	Private $typ, $conn, $DBlib, $srvName;
	
	Public function __construct(){
		if (isset($_POST['server'])){ $this->srvName = $_POST['server'];}
		elseif(isset($_GET['server'])){ $this->srvName = $_GET['server'];}
		else{$this->srvName = '';}
		
		$details = new XmlConfig();
		@$srvDetaily = $details->getServerDet($this->srvName);
		
		@$this->typ = $srvDetaily['Typ'];
		
		if ($this->typ == "mssql"){
			$this->DBlib = new MssqlClass();
		}
		else{
			$this->DBlib = new MysqlClass();
		}
		
		
		@$this->conn = $this->DBlib->connect($srvDetaily['Name'],$srvDetaily['Login'],$srvDetaily['Psw']);
		if(!$this->conn){
		 echo "Nelze se pipojit k DB serveru<br /><br />";	
		}
	}

	
	Public function viewDBs(){
		
		$seznamDB = $this->DBlib->getDatabases($this->conn);
		echo "<h2>Seznam databz na serveru</h2>";
		echo "<table>";
	    echo "<tr><th>Nzev databze</th></tr>";
	    $i = 0;
		foreach($seznamDB as $key){
			if($i % 2 == 0){echo "<tr class='alterRow'>";}
	        else{echo "<tr>";}
			echo "<td><a href='index.php?act=viewDB&server=$this->srvName&DB=$key' class='DBs'><img src='img/db.png' />".$key."</a></td>";
			echo "</tr>";
			$i++;
		}
		echo "</table>";
		
	}
	
	Public function viewDBsMenu(){		
		$seznamDB = $this->DBlib->getDatabases($this->conn);		
		foreach($seznamDB as $key){			
			echo "<a href='index.php?act=viewDB&server=$this->srvName&DB=$key' class='DBs'>".$key."</a><br />";
		}
	}
	
	Public function detailDB($DBname){
	   $this->DBlib->setDB($DBname);
	   $seznamTable = $this->DBlib->getTables($DBname);
	    
	    echo "<h2>Seznam tabulek databze</h2>";
	    echo "<table>";
	    echo "<tr><th>Nzev tabulky</th></tr>";
	     $i = 0;
	     foreach($seznamTable as $key){
	      if($i % 2 == 0){echo "<tr class='alterRow'>";}
	      else{echo "<tr>";}	
	 	  if(substr($key,-1) == "!"){
	        echo "<td>".$key."</td>";	
	      }
	      else{  
			echo "<td><a href='index.php?act=viewDB&server=$this->srvName&DB=$DBname&table=".$key."' class='tables'><img src='img/table.png' />".$key."</a></td>";
			//echo "<td><form action='index.php?act=edit&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$key."&object=table&active=1' method='post'><input type='submit' value='Edit'></form></td>";
	        echo "<td><form action='index.php?act=del&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$key."&object=table&active=6' method='post'><input type='submit' value='Del'></form></td>";
	         
		  }
		  echo "</tr>";
		  $i++;
	    }
	   echo "</table>";
	}
	
	Public function detailDBMenu($DBname){
	   $this->DBlib->setDB($DBname);
	   $seznamTable = $this->DBlib->getTables($DBname);
	    
	    foreach($seznamTable as $key){
	 	  if(substr($key,-1) == "!"){
	        echo $key;	
	      }
	      else{  
			echo "<a href='index.php?act=viewDB&server=$this->srvName&DB=$DBname&table=".$key."' class='tables'>".$key."</a><br />"; 
		  }
	    }
	}
	
	Public function detailTable($tableName,$db){
	   $table = $this->DBlib->describeTable($tableName,$db);
	     
	     echo "<h2>Detail tabulky ".$_GET['table']."</h2>";
	     echo "<table>";
	     echo "<tr><th>Nzev sloupce</th><th>Typ(dlka)</th><th>Null</th><th>Default (DF)</th></tr>";
	     $i=0;
	     foreach($table as $key){
	      if($i % 2 == 0){echo "<tr class='alterRow'>";}
	      else{echo "<tr>";}
	      
	       if(substr($key[2],-1) == "!"){
	         echo "<td>".$key."</td>";	
	       }
	       else{
	       	 if(trim($key[2]) == 'NO'){$key[2] = 'NOT NULL';}
	       	 else{$key[2] = 'NULL';}
	       	 
	       	 echo "<th>$key[0]</th>";
	       	 echo "<td>".$key[1]."</td>";
	       	 echo "<td>".$key[2]."</td>";
	       	 echo "<td>".$key[3]."</td>";
	       	 echo "<td><form action='index.php?act=edit&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&field=".$key[0]."&object=field&active=1' method='post'><input type='submit' value='Edit'></form></td>";
	         echo "<td><form action='index.php?act=del&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&field=".$key[0]."&object=field&active=1' method='post'><input type='submit' value='Del'></form></td>";
	         //$primary = $this->DBlib->getPrimaryKey($_GET['table']);
	         if($this->typ == "mssql" AND  $key[3] != ""){
	         echo "<td><form action='index.php?act=del&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&field=".$key[0]."&object=DF&active=1' method='post'><input type='submit' value='Del DF'></form></td>";	
	         }
	         
		   }
		   echo "</tr>";
		   $i++;
	    }
	    echo "</table>";
	}
	
		
	Public function detailField($fieldName){
		echo $fieldName;
	}
	
	
	Public function viewContentTable($tableName,$db){
	$query = "SELECT * FROM $tableName";
		
	$this->DBlib->setDB($db);
	$table = $this->DBlib->describeTable($tableName,$db);
	$content = $this->DBlib->getRowsQuery($query);
	
	echo "<h2>Obsah tabulky ".$_GET['table']."</h2>";
	echo "<table><tr>";
	foreach($table as $key){
		echo "<th>".$key[0]."</th>";
		$heads[] = $key[0];
	}
	$i=0;
	foreach($content as $keyRow){
		if($i % 2 == 0){echo "<tr class='alterRow'>";}
	    else{echo "<tr>";}
	    
		$row = array();
		foreach($keyRow as $keyData){
			$row[] = $keyData;
			$keyData=wordwrap($keyData,100);
		  echo "<td width='100px'>".$keyData."</td>";	
		}
		echo "<td><form action='index.php?act=edit&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&object=item&active=4' method='POST'>";
		  echo "<input type='hidden' name='numRow' value='$i'>";
		  foreach ($heads as $head){
		  echo "<input type='hidden' name='heads[]' value='$head'>";	
		  }
		  foreach ($row as $item){
		  echo "<input type='hidden' name='row".$i."[]' value='$item'>";
		  }
		echo "<input type='submit' value='Edit' /></form></td>";
		echo "<td><form action='index.php?act=del&server=".$_GET['server']."&DB=".$_GET['DB']."&table=".$_GET['table']."&object=row&active=1' method='POST'>";
		  echo "<input type='hidden' name='numRow' value='$i'>";
		  foreach ($heads as $head){
		  echo "<input type='hidden' name='heads[]' value='$head'>";	
		  }
		  foreach ($row as $item){
		  echo "<input type='hidden' name='row".$i."[]' value='$item'>";
		  }
		echo "<input type='submit' value='Del' /></form></td>";
		
		echo "</tr>";
		$i++;
	}
	echo "</tr>";
	
	echo "</table>";

    }
	
	Public function __destruct(){
		$this->DBlib->close($this->conn);
	}

}
?>
