<?php
Class User{
	Private $typ, $DBlib, $conn;
	
	Public function __construct(){
		$details = new XmlConfig();
		$srvDetaily = $details->getServerDet($_GET['server']);
		$this->typ = $srvDetaily['Typ'];
		
		if ($this->typ == "mssql"){$this->DBlib = new MssqlClass();}
		else{$this->DBlib = new MysqlClass();}	
		$this->conn = $this->DBlib->connect($srvDetaily['Name'],$srvDetaily['Login'],$srvDetaily['Psw']);
		if(!$this->conn){
			echo "Nelze se pipojit k DB serveru<br /><br />";	
		}
		echo "<h2>Sprva uivatel</h2><br />";
		
		if(isset($_POST['privilegesTab'])){
			$this->privileges();	
		}
		elseif(isset($_POST['set'])){
		
			if($this->typ == 'mssql'){$user = $_POST['user'];}
			else{$user = "'".$_POST['user']."'@'".$_POST['host']."'";}
			$this->DBlib->granPrivileges($user,$_GET['DB'],@$_POST['privileges'],@$_POST['privilegesAll']);
		}
		elseif(isset($_POST['createUser'])){
			if($this->typ == 'mssql'){$user = $_POST['user'];}
			else{$user = "'".$_POST['user']."'@'".$_POST['host']."'";}
			
			if($_POST['psw1'] == $_POST['psw2']){
				$password = $_POST['psw1'];
				$this->DBlib->createUser($user,$password);
			}	
			else{
				echo "Zadan hesla jsou rzn!";	
			}
		
			
		}
		else{
			$this->listUsers();
			$this->createUser();
		}
		
	}
	
	Private function listUsers(){
		$users = $this->DBlib->getUsers();
		echo "<table>";
		echo "<tr>";
			echo "<th>Uivatel</th>";
			echo "<th>Login</th>";
			echo "<th>Host</th>";
			echo "<th>Heslo</th>";
		echo "</tr>";
		$i = 0;
		foreach($users as $user){
			if($i % 2 == 0){echo "<tr class='alterRow'>";}
	        else{echo "<tr>";}
				echo "<td>$user[0]</td>";
				echo "<td>$user[1]</td>";
				echo "<td>$user[2]</td>";
				echo "<td>$user[3]</td>";
				echo "<td><form action='index.php?act=user&server=".$_GET['server']."&DB=".$_GET['DB']."&active=3' method='POST'>";
				echo "<input type='hidden' name='user' value='".$user[0]."'>";
				echo "<input type='hidden' name='host' value='".$user[1]."'>";
				echo "<input type='hidden' name='privilegesTab'>";
				echo "<input type='submit' value='Prva'></form>";
				echo "</td>";
			echo "</tr>";
			$i++;
		}
		echo "</table>";
	} 
	
	Private function createUser(){
		if(isset($_GET['confirm'])){
			$this->DBlib->setDB($_GET['DB']);
			$this->BDlib->createUser();
		}
		else{
			echo "<br />Zaloit novho uivatele";
			echo "<form action='index.php?act=user&server=".$_GET['server']."&DB=".$_GET['DB']."&active=3' method='POST'>";
			echo "<table>";
			echo "<tr>";
			echo "<td>Uivatel</td>";
			echo "<td><input type='text' name='user'></td>";
			if($this->typ == 'mysql'){
			echo "<td><input type='text' name='host' value='%'></td>";
			}
			echo "</tr>";
			echo "<tr><td>Heslo</td>";
			echo "<td colspan='2'><input type='password' name='psw1'></td>";
			echo "</tr>";
			echo "<tr><td>Kontrola hesla</td>";
			echo "<td colspan='2'><input type='password' name='psw2'></td>";
			echo "</tr>";
			echo "<tr><td colspan='3'><input type='submit' value='Zaloit'></td></tr>";
			echo "</table>";
			echo "<input type='hidden' name='createUser'>";
			echo "</form>";
			
		}
		
	}
	
	Private function privileges(){
		echo "Sprva pstupovch prv uivatele ".$_POST['host']."/".$_POST['user']." k databzi ".$_GET['DB'];
		echo "<form action='index.php?act=user&server=".$_GET['server']."&DB=".$_GET['DB']."&active=3' method='POST'>";
		if($this->typ == 'mssql'){
			$this->mssqlPriv();
		}
		else{
			$this->mysqlPriv();
		}
		echo "<input type='hidden' name='user' value='".$_POST['user']."' />";
		echo "<input type='hidden' name='host' value='".$_POST['host']."' />";
		echo "<input type='hidden' name='set' />";
		echo "<input type='submit' value='Pijmout' />";
		echo "</form>";
	}
	
	Private function mssqlPriv(){
		echo "<table>";
		 echo "<tr><td>";
		 //data
		 echo "<table>";
		 	echo "<tr><th colspan='2'>Data</th></tr>";
		 	echo "<tr><td>Select</td><td><input type='checkbox' name='privileges[]' value='SELECT' checked='checked' /></td></tr>";
		 	echo "<tr><td>Insert</td><td><input type='checkbox' name='privileges[]' value='INSERT' /></td></tr>";
		 	echo "<tr><td>Update</td><td><input type='checkbox' name='privileges[]' value='UPDATE' /></td></tr>";
		 	echo "<tr><td>Delete</td><td><input type='checkbox' name='privileges[]' value='DELETE' /></td></tr>";
		 echo "</table>";
		 echo "</td>";
		 
		 echo "<td>";
		 //struktura
		 echo "<table>";
		 	echo "<tr><th colspan='2'>Data</th></tr>";
		 	echo "<tr><td>Alter database</td><td><input type='checkbox' name='privileges[]' value='ALTER DATABASE' /></td></tr>";
		 	echo "<tr><td>Alter function</td><td><input type='checkbox' name='privileges[]' value='ALTER FUNCTION' /></td></tr>";
		 	echo "<tr><td>Alterprocedure</td><td><input type='checkbox' name='privileges[]' value='ALTER PROCEDURE' /></td></tr>";
		 	echo "<tr><td>Alter table</td><td><input type='checkbox' name='privileges[]' value='ALTER TABLE' /></td></tr>";
		 	echo "<tr><td>Alter trigger</td><td><input type='checkbox' name='privileges[]' value='ALTER TRIGGER' /></td></tr>";
		 	echo "<tr><td>Alter view</td><td><input type='checkbox' name='privileges[]' value='ALTER VIEW' /></td></tr>";
		 	echo "<tr><td>Create default</td><td><input type='checkbox' name='privileges[]' value='CREATE DEFAULT' /></td></tr>";
		 	echo "<tr><td>Create function</td><td><input type='checkbox' name='privileges[]' value='CREATE FUNCTION' /></td></tr>";
		 	echo "<tr><td>Create index</td><td><input type='checkbox' name='privileges[]' value='CREATE INDEX' /></td></tr>";
		 	echo "<tr><td>Create procedure</td><td><input type='checkbox' name='privileges[]' value='CREATE PROCEDURE' /></td></tr>";
		 	echo "<tr><td>Create rule</td><td><input type='checkbox' name='privileges[]' value='CREATE RULE' /></td></tr>";
		 	echo "<tr><td>Create table</td><td><input type='checkbox' name='privileges[]' value='CREATE TABLE' /></td></tr>";
		 	echo "<tr><td>Create trigger</td><td><input type='checkbox' name='privileges[]' value='CREATE TRIGGER' /></td></tr>";
		 	echo "<tr><td>Create view</td><td><input type='checkbox' name='privileges[]' value='CREATE VIEW' /></td></tr>";
		 	echo "<tr><td>Drop</td><td><input type='checkbox' name='privileges[]' value='DROP' /></td></tr>";
		 echo "</table>";	
		 echo "</td>";
		 
		 echo "<td>";
		 //sprava
		 echo "<table>";
		 	echo "<tr><th colspan='2'>Data</th></tr>";
		 	echo "<tr><td>Backup</td><td><input type='checkbox' name='privileges[]' value='BACKUP' /></td></tr>";
		 	echo "<tr><td>Checkpoint</td><td><input type='checkbox' name='privileges[]' value='CHECKPOINT' /></td></tr>";
		 	echo "<tr><td>DBCC</td><td><input type='checkbox' name='privileges[]' value='DBCC' /></td></tr>";
		 	echo "<tr><td>Deny</td><td><input type='checkbox' name='privileges[]' value='DENY' /></td></tr>";
		 	echo "<tr><td>Execute</td><td><input type='checkbox' name='privileges[]' value='EXECUTE' /></td></tr>";
		 	echo "<tr><td>Grant</td><td><input type='checkbox' name='privileges[]' value='GRANT' /></td></tr>";
		 	echo "<tr><td>Readtext</td><td><input type='checkbox' name='privileges[]' value='READTEXT' /></td></tr>";
		 	echo "<tr><td>References</td><td><input type='checkbox' name='privileges[]' value='REFERENCES' /></td></tr>";
		 	echo "<tr><td>Restore</td><td><input type='checkbox' name='privileges[]' value='RESTORE' /></td></tr>";
		 	echo "<tr><td>Revoke</td><td><input type='checkbox' name='privileges[]' value='REVOKE' /></td></tr>";
		 	echo "<tr><td>Setuser</td><td><input type='checkbox' name='privileges[]' value='SETUSER' /></td></tr>";
		 	echo "<tr><td>Truncate table</td><td><input type='checkbox' name='privileges[]' value='TRUNCATE TABLE' /></td></tr>";
		 	echo "<tr><td>Update statistics</td><td><input type='checkbox' name='privileges[]' value='UPDATE STATISTICS' /></td></tr>";
		 	echo "<tr><td>Updatetext</td><td><input type='checkbox' name='privileges[]' value='UPDATETEXT' /></td></tr>";
		 	echo "<tr><td>Writetext</td><td><input type='checkbox' name='privileges[]' value='WRITETEXT' /></td></tr>";
		 	echo "</table>";	
		 echo "</td>";
		 
		 echo "</tr>";
		echo "<table>";
	}
	
	Private function mysqlPriv(){
		echo "<table>";
		 echo "<tr><td>";
		 //data
		 echo "<table>";
		 	echo "<tr><th colspan='2'>Data</th></tr>";
		 	echo "<tr><td>Select</td><td><input type='checkbox' name='privileges[]' value='SELECT' checked='checked' /></td></tr>";
		 	echo "<tr><td>Insert</td><td><input type='checkbox' name='privileges[]' value='INSERT' /></td></tr>";
		 	echo "<tr><td>Update</td><td><input type='checkbox' name='privileges[]' value='UPDATE' /></td></tr>";
		 	echo "<tr><td>Delete</td><td><input type='checkbox' name='privileges[]' value='DELETE' /></td></tr>";
		 	echo "<tr><td>File</td><td><input type='checkbox' name='privilegesAll[]' value='FILE' /></td></tr>";
		 echo "</table>";
		 echo "</td>";
		 
		 echo "<td>";
		 //struktura
		 echo "<table>";
		 	echo "<tr><th colspan='2'>Data</th></tr>";
		 	echo "<tr><td>Alter</td><td><input type='checkbox' name='privileges[]' value='ALTER' /></td></tr>";
		 	echo "<tr><td>Create</td><td><input type='checkbox' name='privileges[]' value='CREATE' /></td></tr>";
		 	echo "<tr><td>Create temp. tables</td><td><input type='checkbox' name='privileges[]' value='CREATE TEMPORARY TABLES' /></td></tr>";
		 	echo "<tr><td>Create view</td><td><input type='checkbox' name='privileges[]' value='CREATE VIEW' /></td></tr>";
		 	echo "<tr><td>Drop</td><td><input type='checkbox' name='privileges[]' value='DROP' /></td></tr>";
		 	echo "<tr><td>Index</td><td><input type='checkbox' name='privileges[]' value='INDEX' /></td></tr>";
		 	echo "<tr><td>Lock tables</td><td><input type='checkbox' name='privileges[]' value='LOCK TABLES' /></td></tr>";
		 	echo "<tr><td>References</td><td><input type='checkbox' name='privileges[]' value='REFERENCES' /></td></tr>";
		 	echo "<tr><td>Show databases</td><td><input type='checkbox' name='privilegesAll[]' value='SHOW DATABASES' /></td></tr>";
		 	echo "<tr><td>Shov view</td><td><input type='checkbox' name='privileges[]' value='SHOW VIEW' /></td></tr>";
		 	echo "<tr><td>Trigger</td><td><input type='checkbox' name='privileges[]' value='TRIGGER' /></td></tr>";
		 echo "</table>";	
		 echo "</td>";
		 
		 echo "<td>";
		 //sprava
		 echo "<table>";
		 	echo "<tr><th colspan='2'>Data</th></tr>";
		 	echo "<tr><td>Alter routine</td><td><input type='checkbox' name='privileges[]' value='ALTER ROUTINE' /></td></tr>";
		 	echo "<tr><td>Create routine</td><td><input type='checkbox' name='privileges[]' value='CREATE ROUTINE' /></td></tr>";
		 	echo "<tr><td>Create user</td><td><input type='checkbox' name='privilegesAll[]' value='CREATE USER' /></td></tr>";
		 	echo "<tr><td>Event</td><td><input type='checkbox' name='privileges[]' value='EVENT' /></td></tr>";
		 	echo "<tr><td>Execute</td><td><input type='checkbox' name='privileges[]' value='EXECUTE' /></td></tr>";
		 	echo "<tr><td>Process</td><td><input type='checkbox' name='privilegesAll[]' value='PROCESS' /></td></tr>";
		 	echo "<tr><td>Reload</td><td><input type='checkbox' name='privilegesAll[]' value='RELOAD' /></td></tr>";
		 	echo "<tr><td>Replication client</td><td><input type='checkbox' name='privilegesAll[]' value='REPLICATION CLIENT' /></td></tr>";
		 	echo "<tr><td>Replication slave</td><td><input type='checkbox' name='privilegesAll[]' value='REPLICATION SLAVE' /></td></tr>";
		 	echo "<tr><td>Shutdown</td><td><input type='checkbox' name='privilegesAll[]' value='SHUTDOWN' /></td></tr>";
		 	echo "<tr><td>Super</td><td><input type='checkbox' name='privilegesAll[]' value='SUPER' /></td></tr>";
		 	echo "<tr><td>Usage</td><td><input type='checkbox' name='privileges[]' value='USAGE' /></td></tr>";
		 	echo "<tr><td>Grant option</td><td><input type='checkbox' name='privileges[]' value='GRANT OPTION' /></td></tr>";
		 	echo "</table>";	
		 echo "</td>";
		 
		 echo "</tr>";
		echo "<table>";
	}
	
	Public function __destruct(){
		$this->DBlib->close($this->conn);
	}
	
}
?>
